unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;


const
//==========================================================================================
  //document permissions
  PERMISSION_PRINT = 1;
  PERMISSION_COPY = 2;
  PERMISSION_MODIFY = 4;

  //Encryption Level
  RC4_40BITS = 40;
  RC4_128BITS = 128;
//==========================================================================================

type
//SDK interface definitions.
//==========================================================================================
  _FapCreatePDF = function(filename:PChar):Longint; stdcall;
  _FapClose = procedure(id:Longint); stdcall;
  _FapSetPDFSecurity = function(id:Longint;
                                level:Longint;
                                limit:Longint;
                                userpassword:PChar;
                                ownerpassword:PChar):Longint; stdcall;
  _FapSetPDFInfo = function(id:Longint;
                            title:PChar;
                            subject:PChar;
                            author:PChar;
                            keyword:PChar;
                            creator:PChar):Longint; stdcall;
  _FapAddPS = function(id:Longint; filename:PChar):Longint; stdcall;
  _FapConvert = function(id:Longint):Longint; stdcall;
//==========================================================================================

  TMainForm = class(TForm)
    btnDemo: TButton;
    procedure btnDemoClick(Sender: TObject);
  private
    { Private declarations }
    //SDK interface definitions.
    //---------------------------------------------------------------------------
    m_hDll: HMODULE;
    apCreatePDF:  _FapCreatePDF;
    apClosePDF:   _FapClose;
    apAddPS:      _FapAddPS;
    apConvert:    _FapConvert;
    apSetPDFInfo: _FapSetPDFInfo;
    apSetPDFSecurity: _FapSetPDFSecurity;

    function LoadDLL():BOOL;  //Load dynamic link library "ps2pdf.dll"!
    function FreeDLL():BOOL;  //free dynamic link library "ps2pdf.dll"!
    //----------------------------------------------------------------------------

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

//Load dynamic link library---ps2pdf.dll!
function TMainForm.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
  sDllFile := 'ps2pdf.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, '_CreatePDF@4');
	 if pFunc = nil then goto ERR_FLAG;
   apCreatePDF := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_ClosePDF@4');
	 if pFunc = nil then goto ERR_FLAG;
   apClosePDF := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_SetPDFSecurity@20');
	 if pFunc = nil then goto ERR_FLAG;
   apSetPDFSecurity := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_SetPDFInfo@24');
	 if pFunc = nil then goto ERR_FLAG;
   apSetPDFInfo := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_AddPS@8');
	 if pFunc = nil then goto ERR_FLAG;
   apAddPS := pFunc;

	 pFunc := GetProcAddress(m_hDll, '_Convert@4');
	 if pFunc = nil then goto ERR_FLAG;
   apConvert := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;

//Free dynamic link library---ps2pdf.dll!
function TMainForm.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;

//Converting several ps/eps files to one pdf file.
procedure TMainForm.btnDemoClick(Sender: TObject);
var
	id: Longint;
	iPermission: Longint;
	sUserPw: PAnsiChar; //[] = "user";
	sOwnerPw: PAnsiChar; //[] = "owner";
begin
  iPermission := 0;
  sUserPw := 'user';
  sOwnerPw := 'owner';

  // Load dynamic link library "ps2pdf.dll"!
   if LoadDLL() = FALSE then exit;

   id := apCreatePDF('test_mm.pdf');
   if id <> 0 then
   begin
        //setting pdf header information
        apSetPDFInfo(id, 'title', 'subject', 'author', 'keywords', 'createor');

        //setting pdf security
        iPermission := PERMISSION_PRINT or PERMISSION_COPY or PERMISSION_MODIFY;
        apSetPDFSecurity(id, RC4_128BITS, iPermission, sUserPw, sOwnerPw);

        //add PS/EPS files
        apAddPS(id, './ps_files/test1.ps');
        apAddPS(id, './ps_files/test2.ps');
        apAddPS(id, './ps_files/test3.ps');

        //starting convet
        apConvert(id);
        
        //close pdf file
        apClosePDF(id);
   end;

   // Free dynamic link library "ps2pdf.dll"!
   FreeDLL();
end;

end.
